#---------------------------------------------------------------------#
# Ĵ adj_meeting                                      #
#                                                                     #
# Copyright (c) 1995 matsuo@present.forus.or.jp. All rights reserved. #
#---------------------------------------------------------------------#


@MEETING_KEY_REQUIRED =
    ('meeting',
     'organizer',
     'start');

%MEETING_KEY =
    ('meeting' => '̾',
     'organizer' => '',
     'start' => '',	
     'url' => 'URL',	
     'comment' => '');

# Υå
sub check_meeting
{
    local(%data) = @_;

    local(%meeting) = &read_meeting($data{'meeting'});

    unless(defined($meeting{'meeting'}))
    {
	&print_page("礬ꤵƤޤ󡥲򤭤򤷤ƤʤΤǤϤʤǤ礦",
		    'MAIN','','','ᥤ˥塼/goto MENU');
    }

    return(%meeting);
}

sub check_meeting_required
{
    local(%meeting) = @_;

    local($key);

    foreach $key (@MEETING_KEY_REQUIRED)
    {
	defined($meeting{$key})
	    || &print_page("$MEETING_KEY{$key}ꤵƤޤ",
			   'MAIN','','','ᥤ˥塼/goto MENU');
    }
}

sub MEETING_FILE
{
    local($meeting) = @_;

    "$MEETING_DIR/" . &cgi_encode($meeting);
}

sub read_meeting
{
    local($meeting) = @_;

    local($key,$value,%meeting);

    %meeting = &read_db(&MEETING_FILE($meeting));
    %meeting || return 0;

    return %meeting;
}

sub save_meeting
{
    local(%meeting) = @_;

    &check_meeting_required(%meeting);

    &save_db(&MEETING_FILE($meeting{'meeting'}),%meeting)
	    || &print_page(&MEETING_FILE($meeting{'meeting'})
			   . "˽񤭹ޤǤ",
			   'MAIN','','','ᥤ˥塼/goto MENU');
}

sub meeting_info
{
    local(%meeting) = @_;

    local($key,$text);

    foreach $key (sort keys %meeting)
    {
	if(defined($MEETING_KEY{$key}))
	{
	    $text .= "$MEETING_KEY{$key}:\t$meeting{$key}<br>\n";
	}
	else
	{
	    $text .= "$key:\t$meeting{$key}<br>\n";
	}
    }

    return $text;
}

sub selection_meetings
{
    local($organizer) = @_;

    local($text,$meeting);

    $text = "<select name=meeting size=7>\n";
    foreach $meeting (&all_meetings($organizer))
    {
	$text .= "<option>$meeting\n";
    }
    $text .= "</select>\n";

    return $text;
}

sub all_meetings
{
    local($organizer) = @_;

    local(%meetings,$file,$meeting,%meeting);

    foreach $file (<$MEETING_DIR/*>)
    {
	$file =~ /$MEETING_DIR\/(.+)/ || next;
	$meeting = $1;
	$meeting = &cgi_decode($meeting);

	if(defined($organizer))
	{
	    %meeting = &read_meeting($meeting);
	    if($organizer ne $meeting{'organizer'})
	    {
		next;
	    }
	}

	$meetings{$meeting}++;
    }

    return sort keys %meetings;
}

sub resign_organizer
{
    local($meeting) = @_;

    unlink(&MEETING_FILE($meeting))
	|| &print_page("Ǥ(ե)ǤޤǤƥ२顼?",
		       'MAIN','','','ᥤ˥塼/goto MENU');

    &print_page("$meetingδǤޤ<br>
̤δΩƤϡƱ̾β򿷤Ʋ",
		'MAIN','','','ᥤ˥塼/goto MENU');
}

sub view_meeting
{
    local(%meeting) = @_;

    local(%date) = &date31($meeting{'start'});
    local(@member) = &get_member($meeting{'meeting'});

    local(%dc,%join);

    $dc{'comment'} = "<dd>:$meeting{'comment'}<br>\n"
	if($meeting{'comment'} =~ /\S/);

    foreach $date (keys %date)
    {
	unless(defined($meeting{$date})){next;} # ʤʤnext
	$join{$date} .= "";
	$dc{$date} .= "<dd>:$meeting{$date}\n"
	    if($meeting{$date} =~ /\S/);
    }

    foreach $member (sort @member)
    {
	local(%mu) = &read_meeting_user($meeting{'meeting'},$member);

	$dc{'comment'} .= "<dd>$member:$mu{'comment'}<br>\n"
	    if($mu{'comment'} =~ /\S/);

	foreach $date (keys %date)
	{
	    unless(defined($meeting{$date})){next;} # ʤʤnext

	    $join{$date} .= "$member " if(defined($mu{$date}));
	    $dc{$date} .= "<dd>$member:$mu{$date}\n"
		if($mu{$date} =~ /\S/);
	}
    }

    local($date,$text);
    $text = "<dl>\n$dc{'comment'}\n<p>" if(defined($dc{'comment'}));

    foreach $date (sort cmp_date_by_join keys %join)
    {
	$text .= "<dt>$date($date{$date})\n" .
	    join(' / ',split(" ",$join{$date})) .
		"\n$dc{$date}";
    }

    $text .= "\n</dl>";
    return "$text";
}


sub cmp_date_by_join
{
    $_ = split(" ",$join{$b}) <=> split(" ",$join{$a});

    if($_ == 0)
    {
	return $a <=> $b;
    }

    return $_;
}

1;
